package IDA;
use strict;
use warnings;
use IDC;
require Exporter;
our @ISA= qw(Exporter);
our @EXPORT= qw(forrefs forfunctions);

# todo:
#   sub import { my ($pack, @imports)= @_; ... }
#       -> check 'imports' to handle the various
#       'use IDA <params>'  params.

# ... experiment, trying to put 'ea' in caller's namespace.
#   no strict 'refs';
#   use vars qw($ea);
#   my $caller=caller;
#   local(*{$caller."::ea"}) = \my $ea;
sub forfunctions (&)
{
    my ($code)= @_;
    my ($ea, $eea);
    if (SelStart()==BADADDR) {
        $ea= GetFunctionAttr(FirstSeg(), FUNCATTR_START);
        $ea=NextFunction(FirstSeg()) if ($ea==BADADDR);
        $eea= BADADDR;
    }
    else {
        $ea= GetFunctionAttr(SelStart(), FUNCATTR_START);
        $ea=NextFunction(SelStart()) if ($ea==BADADDR);
        $eea= SelEnd();
    }

    while (($eea==BADADDR || $ea < $eea) && $ea!=BADADDR)
    {
        &{$code}($ea);
        $ea=NextFunction($ea);
    }
}
sub foraddrs (&)
{
    my ($code)= @_;
    return if (SelBegin()==BADADDR);

    my $ea= SelBegin();

    while ($ea < SelEnd() && $ea!=BADADDR)
    {
        &{$code}($ea);
        $ea=NextAddr($ea);
    }
}
sub forheads (&)
{
    my ($code)= @_;
    return if (SelBegin()==BADADDR);

    my $ea= SelBegin();

    while ($ea < SelEnd() && $ea!=BADADDR)
    {
        &{$code}($ea);
        $ea=NextHead($ea, SelEnd());
    }
}
# forrefs($ea, "DB", { ... }) 
# is like for (local $_=DfirstB($ea) ; $_!=BADADDR ; $_=DnextB($ea,$_)) { ... }
# IDA::forrefs(ScreenEA(), "DB", sub { printf("%08lx\n", $ea); });
sub forrefs ($$&)
{
    my ($rea, $filter, $code)= @_;
    my %reffuncs= (
        "DB"=>{first=>\&IDC::DfirstB, next=>\&IDC::DnextB},
    );
    my $first= $reffuncs{$filter}{first};
    my $next= $reffuncs{$filter}{next};

    for (my $ea=&{$first}($rea) ; $ea!=BADADDR ; $ea=&{$next}($rea,$ea)) { &{$code}($ea); }
}

1;
